码迷,mamicode.com
首页 > 其他好文 > 详细

HDU 1501

时间:2015-07-11 12:15:59      阅读:119      评论:0      收藏:0      [点我收藏+]

标签:

Zipper

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 7813    Accepted Submission(s): 2765

Problem Description
Given three strings, you are to determine whether the third string can be formed by combining the characters in the first two strings. The first two strings can be mixed arbitrarily, but each must stay in its original order.
For example, consider forming "tcraete" from "cat" and "tree":
String A: cat
String B: tree
String C: tcraete

As you can see, we can form the third string by alternating characters from the two strings. As a second example, consider forming "catrtee" from "cat" and "tree":
String A: cat
String B: tree
String C: catrtee
Finally, notice that it is impossible to form "cttaree" from "cat" and "tree".
 
Input
The first line of input contains a single positive integer from 1 through 1000. It represents the number of data sets to follow. The processing for each data set is identical. The data sets appear on the following lines, one data set per line.
For each data set, the line of input consists of three strings, separated by a single space. All strings are composed of upper and lower case letters only. The length of the third string is always the sum of the lengths of the first two strings. The first two strings will have lengths between 1 and 200 characters, inclusive.


Output
For each data set, print:
Data set n: yes
if the third string can be formed from the first two, or
Data set n: no
if it cannot. Of course n should be replaced by the data set number. See the sample output below for an example.
 
Sample Input
3
cat tree tcraete
cat tree catrtee
cat tree cttaree
 
Sample Output
Data set 1: yes
Data set 2: yes

Data set 3: no

//本题主要思路根据第三个字符串dnf搜索从前两个字符串中查找,查找到的字符放入数组res中,当res与第三个字符串相等时搜索结

//束

#include <stdio.h>
#include <string.h>
char ss[420];
char s1[210];
char s2[210];
char res[420];
bool vis[210][210];   //用数组记录很重要不然会超时
int flag,cnt,len1,len2;
void dfs(int ini,int init)
{
    if(vis[ini][init]) return;
    vis[ini][init]=1;      
    if(strcmp(res,ss)==0)
    {
        flag=1;
        return;
    }
    else
    {
            if(s1[ini]==ss[cnt])  //当搜索到与第三字符串中的字符相等时记录下字符再递归搜索
            {
                res[cnt++]=s1[ini];
                dfs(ini+1,init);
                cnt--;
                if(flag)
                    return;
            }
         if(s2[init]==ss[cnt])
            {
                res[cnt++]=s2[init];
                dfs(ini,init+1);
                cnt--;
                if(flag)
                    return;

            }
    }
}

int main()
{
    int n;
    int cnt1=1;
    scanf("%d",&n);
    getchar();
    while(n--)
    {
        scanf("%s%s%s",s1,s2,ss);
        len1=strlen(s1);
        len2=strlen(s2);
        cnt=flag=0;
        memset(res,'\0',sizeof(res));  //我调试了快半个小时了,才发现如果用0的话数组不能完全清空
        memset(res,0,sizeof(vis));
        dfs(0,0);
        printf("Data set %d:",cnt1++);
        if(flag)
            printf(" yes\n"); //注意空格
        else
            printf(" no\n");
    }
    return 0 ;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

HDU 1501

标签:

原文地址:http://blog.csdn.net/a73265/article/details/46839997

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!